#
# spec file for package Intel-v92ham (Version 4.12.3)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  autoconf bin86 gmp k_deflt kernel-source modutils openssl openssl-devel
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bin86 bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gmp gpm gppshare grep groff gzip k_deflt kbd kernel-source less libtool libz m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openssl openssl-devel pam pam-devel patch perl ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim

Name:         Intel-v92ham
%define srcdir Intel-v92ham-412-3
%define pversion 4.12-3
%define susedir "SuSE"
Version:      4.12.3
Release:      97
Copyright:    Intel Corporation
Group:        System Environment/Base
ExclusiveArch: i386
#Requires:      
Autoreqprov:  on
Summary:      Driver for Intel's v92 HaM modem
Source:		Intel-v92ham-412-3.tar.gz
Source1:	Intel-v92ham-%{pversion}.SuSE.tar.gz
Patch:		Intel-v92ham-%{pversion}.diff
URL:		http://www.intel.com

%description
This package includes the drivers and configuration tools for the
Intel HaM Modem with MD563X-HaM V.90 chipset.
It is a controllerless modem and so sometimes called a "winmodem"
(or in this case a linmodem).
This is not completely free sofware!.
Please read the license agreement in
/usr/share/doc/packages/Intel-v92ham/license.txt
As this driver is binary only, please note, that SuSE can offer
no installation support
for this modems!!

Authors:
--------
    Dorian Araneda <dorian.araneda@intel.com>

SuSE series: pay

%define modrootdir lib/modules/
%define filelist /var/adm/fillup-templates/Intel-v92ham-moduleslist
%prep
%setup -n %{srcdir} -a 1
%patch -p1

%build
function setup_includes() {
# setup the kernel includes
# according to L.T. recommended
# see /usr/include/linux/version.h
# export the include directory and the directory where the modules 
# are located.
# use it in the makefile !
    IVHEAD="include/linux/version.h"
    KVER=$1
    COPYBVHEAD='n'
    LINKBUILDDIR='n'
    test -z "${KVER}" && {
	SRCDIR="/usr/src/linux"
	BVHEAD="/boot/vmlinuz.version.h"
	test -r "${BVHEAD}" && {
	    KVER=`grep UTS_RELEASE /boot/vmlinuz.version.h | cut -f3 -d' ' \
		| tr -d '"'`
	} || {
	    echo 'no kernel version given'
	    KVER=`uname -r`
	}
    } || {
	SRCDIR=`ls -d /usr/src/linux*${KVER} 2>/dev/null`
	BVHEAD=`ls -d /boot/vmlinuz.version*${KVER}.h 2>/dev/null`
    }
    MODDIR="/%{modrootdir}/${KVER}"
    BUILDDIR="${MODDIR}/build"
    KVERNUM=`echo $KVER | cut -c1,3`
    test $KVERNUM -ge 24 && \
	MODSUBDIR=${MODDIR}/kernel/drivers/char || \
	MODSUBDIR=${MODDIR}/misc
    test -d "${SRCDIR}" || {
	echo "no valid source tree: ${SRCDIR}"
	return 1; 
    }
    test -d "${MODDIR}" || {
	echo creating ${MODSUBDIR}
	mkdir -p ${MODSUBDIR}
    }
    test -L "${BUILDDIR}" || {
	echo "setting up kernel include environment"
	echo "(see /usr/include/linux/version.h)"
	echo "using version file ${BVHEAD} and source tree ${SRCDIR}"
	#make the link
	ln -sv "${SRCDIR}" "${BUILDDIR}" && LINKBUILDDIR='y'
    }
    test -r "${BVHEAD}" && {
	# copy versioninfo from /boot file
	test -e "${BUILDDIR}/${IVHEAD}" && {
	    echo "saving existing ${IVHEAD}"
	    cp -v "${BUILDDIR}/${IVHEAD}" "${BUILDDIR}/${IVHEAD}.orig"
	}
	cp -v "${BVHEAD}" "${BUILDDIR}/${IVHEAD}" && COPYBVHEAD='y'
    }|| {
	echo "no valid header version file in /boot found"
	echo "hope the existing ${BUILDDIR}/${IVHEAD} is valid"
    }
    # export the include and modules directory
    export INCLUDES="-I ${BUILDDIR}/include -I ../inc"
    export MODSUBDIR
}
function restore_includes {
# restoring original state of include files and link
    test "$COPYBVHEAD" = 'y' && {
	test -e "${BUILDDIR}/${IVHEAD}.orig" && {
	    echo "restoring original ${IVHEAD}"
	    cp ${BUILDDIR}/${IVHEAD}.orig ${BUILDDIR}/${IVHEAD}
	}
    }
    test "$LINKBUILDDIR" = 'y' && {
	echo "unlinking ${BUILDDIR}"
	rm ${BUILDDIR}
    }
    return 0
}
function makemodules() {
# make modules for a given kernelversion
    retval=1
    setup_includes $1 && make clean all && {
	retval=0
	SUCCESS='y'
	for i in ./${MODSUBDIR}/*; do echo /$i >> %{filelist}; done
    }
    restore_includes
    return 0
}
SUCCESS='n'
rm  -f %{filelist}
#comment the following line out!
#KERNELVER="2.4.4-4GB"
echo KERNELVER="$KERNELVER"
for i in "" $KERNELVER; do
    makemodules $i
done
test ${SUCCESS} = 'y' || {
    echo no modules compiled
    exit 1
}
exit 0

%install
GROUP='dialout'
MODE='664'
# install the registry
install -o root -g root -m 110 hamregistry /usr/sbin
install -o root -g root -m 444 linhamreg.bin /etc
# install the modules
find %{modrootdir} -type d | xargs -i \
    test -d $RPM_BUILD_ROOT/{} || \
    install -o root -g root -m 755 -d $RPM_BUILD_ROOT/{}
find %{modrootdir} -type f | xargs -i \
    install -o root -g root -m 644 {} $RPM_BUILD_ROOT/{}
test -e /dev/ham && rm /dev/ham -f
# setting up ham device
MAJOR=`cat /proc/devices | awk "\\$2==\"$serial\" {print \\$1}"`
test -z "$MAJOR" && MAJOR='240'
mknod /dev/ham c $MAJOR 1;
chgrp ${GROUP} /dev/ham
chmod ${MODE}  /dev/ham
#ln -sf /dev/ham /dev/modem 1> /dev/null 2> /dev/null
# adjusting modules.conf
install -m 644 %{susedir}/modules.conf.ham /var/adm/fillup-templates/modules.conf.ham
# filelist contains the pathes to the modules

%files -f %{filelist}
/dev/ham
/usr/sbin/hamregistry
/var/adm/fillup-templates/modules.conf.ham
%config /etc/linhamreg.bin 
%doc readme.txt license.txt SuSE/README.SuSE SuSE/TODO 

%post
cat <<EOT
 Copyright (c) 1999-2001, Intel Corporation All rights reserved.
 Parts of this software are not GPL authorized and not free!
 Please read INTEL SOFTWARE LICENSE AGREEMENT
 in /usr/share/doc/packages/Intel-v92ham/license.txt
 before using the modules!
 As this driver is binary only, please note, that SuSE can offer 
      no installation support 
 for this modem.
 If you have any questions, please look at http://developer.intel.com/design/modems 
EOT
HAMMOD="/var/adm/fillup-templates/modules.conf.ham"
test -w /etc/modules.conf && {
    grep "`sed -n 1p $HAMMOD`" /etc/modules.conf &>/dev/null || {
	echo "Updating etc/modules.conf"
	cat $HAMMOD >> /etc/modules.conf
	test -x sbin/depmod -a -e lib/modules/`bin/uname -r`/modules.dep && {
	    chroot . /sbin/depmod -a 2>/dev/null
	}
    }
} || {
  echo "ERROR: /etc/modules.conf not writable. This should not happen."
  echo "Please see modules.conf.ham for necessary changes and "
  echo "update by hand."
  exit 1
}
exit 0

%preun
HAMMOD="/var/adm/fillup-templates/modules.conf.ham"
test -w /etc/modules.conf || {
    echo "cannot find /etc/modules.conf. Nothing to remove from moduled.conf"
    exit 0
}
TMP=`mktemp -q /tmp/$base.XXXXXX`
test $? -ne 0 && {
    echo "$base: Can't create temp file, exiting..."
    exit 1
}
LNO=`wc -l $HAMMOD`
FL=`sed -n -e '1p' $HAMMOD | tr '/' '.'`
LL=`sed -n -e '$p' $HAMMOD | tr '/' '.'`
echo trying to remove the following lines from
echo "  $FL"
echo to
echo "  $LL"
echo from /etc/modules.conf
sed  -e "/$FL/,/$LL/d" /etc/modules.conf > $TMP
test $? -eq 0 -a \
   -n "$FL" -a -n "$LL" -a \
   -r "$TMP"  &&  {
    echo saving old /etc/modules.conf in /etc/modules.conf.rpmold
    mv /etc/modules.conf /etc/modules.conf.rpmold
    mv $TMP /etc/modules.conf
    echo removing ham-module entries from /etc/modules.conf done
} || {
    echo cannot remove the Intel-v92ham entries from /etc/modules.conf
    rm -f $TMP
    exit 0
}

%postun

%changelog -n Intel-v92ham
* Tue Sep 18 2001 - hoelcker@suse.de
- re-activate KVER
* Fri Sep 14 2001 - hoelcker@suse.de
- Kernelversion is taken from ther /boot/vmlinuz*verion.h file, if
  present
- added hint to the intel developers site
  http://developer.intel.com/design/modems
* Wed Aug 29 2001 - hoelcker@suse.de
- initial build of the rpm package
- adjustments in the original tarball made for the rpm package:
- the INCLUDE directory for the makefile can be given as an environment
  variable, too.
- the environment variable MODSUBDIR points to the directory where the
  compiled modules are stored.
  Together with the INCLUDE variable this could be used to compile modules
  for more than one kernel at one time.
- installation procedure ha smoved from the makefile to the specfile
- the build section set up the INCLUDE path variable for compiling
  correctly
- the environment variable KERNELVER is evaluated by the specfile to
  compile the modules for more than one kernelversion.
  See the specfile for further information.
- switch version from 408-2 to 412-3.
  tarfile is now Intel-v92ham-412-3.tar.gz
  src subdirectory is Intel-v92ham-412-3
  SuSE source file is now Intel-v92ham-4.12-3.SuSE.tar.gz
  SuSE diff file is now Intel-v92ham-4.12-3.diff
- Added new features:
- Using the modules.conf to load and unload the modules and not the hamboot
  script
- modules.conf is updated during installation and deinstallation
- Using the install section of the specfile for installation procedure
  and not the haminstall script
- the link /dev/modem is no more created automatically
- rebuilding of the package for more than one kernelversion is possible
  using the KERNELVER environment variable
- the specfile is GPL authorized
